%%STARTSHELL%%
#	Copyright 1985, 1986, 1987, 1988, 1989, 1990, 1991 Chris Lewis
#		All Rights Reserved
#
#    See the LICENSE file for a full description of the restrictions
#    under which this software is provided.
#
#1.11 93/03/14
MAKEDEV=%%MAKEDEV%%
LIBDIR=%%LIBDIR%%
if [ "$1" = "-i" ]
then
    install=1
fi
rm -f DITLIST */ditdone
sed -e '/^[^#].*-N/!d' ../lib/psrofflib > DITLIST
tlist=`sed -e 's/[ 	][ 	]*.*//' DITLIST`
rm -f */ditdone
for i in $tlist
do
    Targ=
    Warg=
    Garg=
    width=
    eval `sed -n -e "/^$i[ 	]/s///p" DITLIST`
    eval "`echo $t2arg | sed -n -e 's/.*-T\([^ 	]*\).*/Targ=\1/p'`"
    eval "`echo $t2arg | sed -n -e 's;.*-W\([^ 	]*\).*;Warg=\1;p'`"
    eval "`echo $t2arg | sed -n -e 's;.*-G\([^ 	]*\).*;Garg=\1;p'`"
    if [ -n "$Warg" ]
    then
	srcfont=`basename $Warg`
    else
	srcfont=$Targ
    fi
    echo "CHECKING $i: width=$width, psroff widths: $srcfont"
    if [ -z "$width" ]
    then
	echo "Something wrong with $i entry, skipping (no width)"
	continue
    fi
    dir=width$srcfont
    if [ ! -d $dir ]
    then
	echo "$dir does not exist (for driver $i)"
	continue
    fi
    if [ ! -r $dir/DESC ]
    then
	echo "No DESC file for $dir, skipping"
	continue
    fi
    if [ -z "$install" ]
    then
	if [ ! -r $MAKEDEV ]
	then
	    echo "No MAKEDEV ($MAKEDEV) skipping"
	    continue
	fi
	if [ -r $dir/ditdone ]
	then
	    continue
	fi
	touch $dir/ditdone
	cd $dir
	find . '(' -name '[A-Z]' -o -name '[A-Z][A-Z]' ')' \
	    -exec $MAKEDEV DESC '{}' ';'
	$MAKEDEV DESC
	cd ..
    else
	groffpostpro=''
	if [ -n "$Garg" ]
	then
	    if [ ! -d %%GFONTDIR%% ]
	    then
		echo "No %%GFONTDIR%% - looks like DWB 3.x"
		destdir=%%FONTDIR%%/dev$width
	    else
		echo "H'm, looks like groff width tables in %%GFONTDIR%%"
		destdir=%%GFONTDIR%%/dev$width
		groffpostpro=$LIBDIR/troff2ps_$width
	    fi
	else
	    destdir=%%FONTDIR%%/dev$width
	fi
	if [ ! -d $destdir ]
	then
	    mkdir $destdir
	    chmod 755 $destdir
	    echo "Psroff-built width tables" > $destdir/PSROFF-BUILT
	    chmod 644 $destdir/PSROFF-BUILT
	fi
	if [ ! -w $destdir ]
	then
	    echo "Can't create $destdir or can't write in it"
	    continue
	fi
	if [ ! -r $destdir/PSROFF-BUILT ]
	then
	    echo "SKIPPING INSTALL of $dir into $destdir:"
	    echo "  probably pre-existing, won't overwrite"
	    echo "  touch $destdir/PSROFF-BUILT to overwrite anyways"
	    continue
	fi
	cd $dir
	if [ -z "$Garg" ]
	then
	    list="`find . -name '*.out' -print`"
	else
	    list="`find . -name '[A-Z]*' -a ! -name '*.out' -print`"
	fi

	if [ -n "$list" ]
	then
	    echo "INSTALLING ditroff widths from $dir into $destdir"
	    cp $list $destdir
	    chmod 644 $destdir/*
	    if [ -n "$groffpostpro" ]
	    then
		echo "  inserting groff postpro line into $destdir/DESC"
		sed -e "/font/a\\
postpro $groffpostpro" $destdir/DESC > /tmp/$$
		mv /tmp/$$ $destdir/DESC
		chmod 644 $destdir/DESC
		echo "   installing groff postprocessor in $LIBDIR"
		rm -f $groffpostpro
		echo "$LIBDIR/troff2ps $t2arg \$@" > $groffpostpro
		chmod 755 $groffpostpro
	    fi
	fi
	cd ../
    fi
done
rm -f */ditdone DITLIST
